Function binSearch
   /* 
     ------------------------------------------------------------------
     Programmer..: Roland Wingerter
     Date........: October 2003
     Notes.......: Binary search in a sorted array. 

                   Generally, the array's scan method is very fast,
                   but with very large arrays (> 100.000 elements),
                   a binary search will be faster. 

                   Note that the array must be sorted.  

     Written for.: dBase Plus
     
     Rev. History: None

     Calls.......: None

     Usage.......: set procedure to binsearch.prg additive
                   r = binsearch(oArray, ValueToFind) 

     Example.....: 
     Returns.....: 
     Parameter...:  
     ------------------------------------------------------------------
  */

   parameters oArray, xKey 

   local nLow, nHigh, nMiddle

   if type("oArray") # 'A'
      msgbox("No array passed","Error",16)
      return false
   elseif xKey < oArray[1] ;    
      or (xKey > oArray[oArray.Size])
      return 0
	elseif xKey == oArray[1]
      return 1
	elseif xKey == oArray[oArray.Size]
      return oArray.Size
   endif

   nLow 	= 1
   nHigh = oArray.Size

   nCount = 0
   do while nLow+1 # nHigh
      nMiddle = int((nLow+nHigh)/2)

      nCount++
      do case
         case oArray[nMiddle] == xKey
            ? nCount, nMiddle
            return nMiddle

         case oArray[nMiddle] > xKey 
           	nHigh = nMiddle

         case oArray[nMiddle] < xKey                        
            nLow = nMiddle

      endcase
	enddo
return 0

