/*
    -----------------------------------------------------------
    custbuttPortuguese.h
    February 15, 1999
    Ken Mayer
    Portuguese Translation of "custButtEnglish.h" 
       by Nuno Ricardo (Belas-Lisboa)

     *** Note: you should copy this file to your
     ..\Visual dBASE\INCLUDE directory for it to
     be used properly by all of your applications.

    This is an 'include' file with the speedTips and
    message box text for each of the buttons in CUSTBUTT.CC.
    The idea is that by defining them here, someone using
    another language can copy this file and translate the
    text in the .H file, and the only change necessary in
    CUSTBUTT.CC is the #INCLUDE statement to include
    the correct file.

    When translating, make sure you do NOT change the names
    of the constants ...

    *****************
    November 11, 2000
    *****************
    NOTE: If you update your application to use the 
    CUSTBUTT.CC file from dUFLP version 2KC (DUFLP2KC.EXE),
    then you MUST update your .H file -- this is a fix based
    on a discovery that EMPTYTABLE and FILTER strings could
    cause problem in code that used the database object
    emptyTable method, or the rowset object's filter property.
    These strings are defined as EMPTYTABLETEXT and FILTERTEXT
    now, and will not cause a conflict.

    Suggestion by Francesco Navarria, in Italy ...
    **********************************************************
    *** WARNING: If you are not using an ANSI language driver
    *** for your tables (at the Command window: ? LDRIVER()
    *** it should be obvkous) or have the setting:
    ***  LDRIVER=WINDOWS in your VDB.INI file (under the
    *** [CommandSettings] heading) do NOT attempt save
    *** this file ... you can wipe out the upper ANSI characters
    *** used. 
    **********************************************************
    -----------------------------------------------------------
*/

// ----------------------------------------------------------
// botes de navegao:
                                //"First row in rowset"
#define TOPTIP                  "Primeira linha"
                                //"Previous row in rowset"
#define PREVTIP                 "Linha anterior"
                                 //"Next row in rowset"
#define NEXTTIP                 "Linha seguinte"
                                //"Last row in rowset"
#define ENDTIP                  "ltima linha"

// ----------------------------------------------------------
// botes de edio:
                                //"Add new row"
#define ADDTIP                  "Adicionar nova linha"
                                //"Copy data to a new Row"
#define CARRYTIP                "Copiar dados para uma nova linha"
                                //"Edit current row"
#define EDITTIP                 "Editar linha actual"
                                //"Save current row"
#define SAVETIP                 "Gravar linha actual"
                                //"Delete current row"
#define DELETETIP               "Apagar linha actual"
                                //"Abandon changes to row"
#define ABANDONTIP              "Cancelar alteraes da linha"
// ----------------------------------------------------------
// botes de filtro e busca:
                                //"Filter/Run/Clear Filter"
#define FILTERTIP               "Filtra/Activar/Desactivar o filtro"
                                //"Locate/Run/Clear Locate"
#define LOCATETIP               "Localizar/Activar/Desactivar Busca"

// ----------------------------------------------------------
// botes de clipboard:
                                //"Cut selected text"
#define CUTTIP                  "Eliminar texto seleccionado"
                                //"Copy selected text"
#define COPYTIP                 "Copiar texto seleccionado"
                                //"Paste from clipboard"
#define PASTETTIP               "Copiar da memria"

// ----------------------------------------------------------
// botes diversos:
                                //"Close this form"
#define CLOSETIP                "Encerrar janela"
                                //"Yes"
#define YESTIP                  "Sim"
                                //"No"
#define NOTIP                   "No"
                                //"Cancel"
#define CANCELTIP               "Cancelar"
                                //"Question? Help?"
#define QUESTIONTIP             "Pergunta? Ajuda?"
                                //"Run"
#define RUNTIP                  "Executar"
                                //"Information"
#define INFOTIP                 "Informao"
                                //"Restore from disk"
#define RESTOREFROMDISKTIP      "Recuperao a partir do disco"
                                //"Save to disk"
#define SAVETODISKTIP           "Gravar no disco"
                                //"Open file ..."
#define OPENFILETIP             "Abrir arquivo ..."
                                //"Tool Button"
#define TOOLBUTTONTIP           "Boto de Ferramentas"
                                //"Print"
#define PRINTTIP                "Imprimir"
                                //"Search"
#define SEARCHTIP               "Busca"
                                //"Continue search"
#define SEARCHAGAINTIP          "Continuar a busca"
                                //"Replace"
#define REPLACETIP              "Substituir"
                               //"Exit"
#define EXITTIP                 "Sair"
                                //"First Page"
#define FIRSTPAGETIP            "Primeira Pgina"
                                //"Next Page"
#define NEXTPAGETIP             "Pgina Seguinte"
                                //"Previous Page"
#define PREVIOUSPAGETIP         "Pgina Anterior"
                                //"The Light Goes Off"
#define LIGHTBULBTIP            "A luz vai-se desligar"


// ----------------------------------------------------------
// variveis utilizadas nas caixas de dilogo em CUSTBUTT.CC
// ----------------------------------------------------------

// Este aparece como ttulo de diversas caixas de dilogo
                                //"Can't do it!"
#define CANTDOIT                "No posso faz-lo!"

// ----------------------------------------------------------
// Um destes aparece a qualquer momento quando verificamos se o grupo de registos  
// nulo e  o texto da caixa de mensagem
                                //"Cannot Navigate with no rowset!"
#define NAVNOROWSET             "No posso navegar sem grupo de registos"
                                //"Cannot add rows with no rowset!"
#define ADDNOROWSET             "No posso adicionar linhas sem grupo de registos"
                                //"Cannot copy rows on a form without a rowset!"
#define COPYNOROWSET            "No posso copiar linhas de uma janela sem grupo de registos"
                                //"Cannot update rows on a form without a rowset!"
#define EDITNOROWSET            "No posso actualizar as linhas de uma janela sem grupo de registos"
                                //"Cannot save changes to rows on a form without a rowset!"
#define SAVENOROWSET            "No posso gravar alteraes s linhas sem grupo de registos"
                                //"Cannot save delete rows on a form without a rowset!"
#define DELETENOROWSET          "No posso gravar ou apagar linhas sem grupo de registos"
                                //"Cannot abandon changes to rows on a form without a rowset!"
#define ABANDONNOROWSET         "No posso abandonar altereaes de linhas de uma janela sem grupo de registos"
                                //"Cannot filter an empty or missing rowset!"
#define FILTERNOROWSET          "No posso filtrar sem grupo de registos ou num grupo vazio"
                                //"Cannot perform a locate with no rowset!"
#define LOCATENOROWSET          "No posso executar uma busca sem grupo de registos"

// ----------------------------------------------------------
// Este  o ttulo e a mensagem quando o utilizador tenta
// navegar ou fechar uma janela e os dados foram alterados
                                //"Data has changed"
#define DATACHANGED             "Os  dados foram alterados"
                                //"Save changes before leaving record?"
#define SAVECHANGES             "Gravar alteraes do registo antes de sair?"

// ----------------------------------------------------------
// Ttulo para quando o utilizador no consegue navegar
                                //"Can't Navigate!"
#define CANTNAVIGATE            "Navegao impossvel"

// ----------------------------------------------------------
// Outras mensagens...
                                //"You are in filter mode"
#define INFILTERMODE            "Est no modo Filtrar"
                                //"You are in locate mode"
#define INLOCATEMODE            "Est no modo Localizao"
                                //"At first row in rowset"
#define ATFIRSTROW              "Est na primeira linha do grupo"
                                //"At last row in rowset"
#define ATLASTROW               "Est na ltima linha do grupo"
                                //"Row is copied -- you are in append mode. Make changes and save or abandon new row."
#define ROWISCOPIED             "Linha  copiada: est no modo Adicionar. Faa alteraes e grave ou abandone a nova linha"
                                // "Row is being edited by another. Try again later."
#define ROWLOCKED               "A linha est a ser editada por outro utilizador. Tente de novo mais tarde."
                                //"Cannot Save edits/new row when you weren't editing/adding"
#define NOTEDITING              "Impossvel gravar edies/novos registos quando no est editando ou adicionando registos"
                                //"Key Violation - That Key already exists."
#define KEYVIOLATION            "Violao de chave: Est chave j existe."
                                //"Unknown error -- "
#define UNKNOWNERROR            "Erro desconhecido"
                                //"You are about to delete the current row." + CHR(13) + "Click Yes to delete the current row."
#define DELETEYESNO             "Est prestes a eliminar a linha seleccionada." + CHR(13) + "Clique Sim para apagar a linha actual."
                                //"Nothing to delete!"
#define NOTHINGTODELETE         "Nada para apagar!"
                                //"Abandoning the row will cancel the filter!"
#define ABANDONWILLCANCELFILTER "Abandonando a linha ir cancelar o filtro!"
                                //"Abandoning the row will cancel the locate!"
#define ABANDONWILLCANCELLOCATE "Abandonando a linha ir cancelar a busca"
                                //"Cannot Abandon edits/new row when you weren't editing/adding!"
#define NOTHINGTOABANDON        "Impossvel abandonar edies/novos registos quando no est editando ou adicionando!"
                                //"No Match"
#define NOMATCH                 "No localizado"
                                //"Exit from filter mode!"
#define EXITFROMFILTER          "Sair do modo Filtro!"
                                //"No more matches!"
#define NOMOREMATCHES           "No existem mais registos localizados"
                                //"Can't search in memo field!"
#define CANTSEARCHINMEMO        "No se pode localizar no campo de MEMO!"
                                //"Can't filter on a memo field!"
#define CANTFILTERINMEMO        "No se pode filtrar no campo de MEMO!"

// ------------------------------------------------------------
// Ttulos diversos
                                //"Can't Add a new row!"
#define CANTADDROW              "No pode adicionar nova linha!"
                                //"Can't Copy row!"
#define CANTCOPYROW             "No pode copiar linha!"
                                //"Copy complete"
#define COPYCOMPLETE            "Cpia completa"
                                //"Can't Edit row!"
#define CANTEDITROW             "No pode editar linha!"
                                //"Can't Save row!"
#define CANTSAVEROW             "No pode guardar a linha!"
                                //"No changes to save!"
#define NOCHANGES               "Nenhumas alteraes para guardar!"
                                //"Can't Delete row!"
#define CANTDELETEROW           "No pode apagar a linha!"
                                //"Alert"
#define ALERT                   "Alerta"
                                //"Empty table"
#define EMPTYTABLETEXT          "Tabela vazia"
                                //"Cancel Filter?"
#define CANCELFILTER            "Cancelar Filtro?"
                                //"Cancel Locate?"
#define CANCELLOCATE            "Cancelar Busca?"
                                //"Can't abandon row!"
#define CANTABANDONROW          "No pode abandonar linha!"
                                //"Can't set a filter!"
#define CANTSETFILTER           "No definir um filtro!"
                                //"Filter"
#define FILTERTEXT              "Filtro"
                                //"Can't start a search!"
#define CANTSEARCH              "No pode iniciar busca!"
                                //"Search"
#define SEARCH                  "Busca"

// -----------------------------------------------------------
// kmRowState -- estados:
//"Fechado"
#define STATECLOSED             "Fechado"
                                //"View" // or "Browse"
#define STATEVIEW               "Ver" // or "Browse"
                                //"Edit"
#define STATEEDIT               "Editar"
                                //"Append"
#define STATEAPPEND             "Adicionar"
                                //"Filter"
#define STATEFILTER             "Filtro"
                                //"Locate"
#define STATELOCATE             "Localizar"

// -----------------------------------------------------------
// Fim do ficheiro header : custButtPortugues.h
// -----------------------------------------------------------

