// Procedure-Datei fuer tableinfo.wfm
// Version 1.3

// enthaelt
// tablecreate, erstellen der Tabellen
// registry, Zugriff auf die Registry Datei, wird aufgerufen von getBDEversion
// getBDEversion, zeigt BDE Version an ber API
//
// Anmerkung:
// Die numerischen Felder wurden mit INTEGER erzeugt, weil bei SQL Parameter
// INSERT und UPDATE Felder vom Typ NUMERIC oder DOUBLE eine Fehlermeldung
// erzeugen
//-----------------------------------------------------------------------------


PROCEDURE tablecreate

CREATE TABLE "__konvert__" ( ;
      Tabelle        CHAR(50), ;
      Typ            CHAR(2), ;
      Treiber        CHAR(20), ;
      RecAnzahl      INTEGER, ;
      FiAnzahl			INTEGER, ;
      IndAnzahl		INTEGER)

CREATE INDEX tabelle ON "__konvert__" (tabelle)

CREATE TABLE "__konvertfeld__" ( ;
      Tabelle        CHAR(50), ;
      Feldname       CHAR(32), ;
      Typ            CHAR(15), ;
      Laenge         INTEGER, ;
      Dez            INTEGER)

CREATE INDEX tabelle ON "__konvertfeld__" (tabelle)

CREATE TABLE "__konvertindex__" ( ;
      Tabelle        CHAR(50), ;
      Indexname      CHAR(32), ;
      PKey           BOOLEAN, ;
      Uniind         BOOLEAN, ;
      Disind         BOOLEAN, ;
      Fallend        BOOLEAN, ;
      Ausdruck       CHAR(220), ;
      ForAusdr       CHAR(220))

CREATE INDEX tabelle ON "__konvertindex__"(tabelle)



PROCEDURE registry

//------------------------------------------------------------------------
//
//  Registry.prg  --  Windows-32-Systemregistrierungsklasse
//
//  Dieses Registrierungsprogramm enthlt die Klassendefinition
//  fr die Klasse Registry. Mit dieser Klasse knnen Sie Werte in
//  die Windows-32-Registrierung schreiben und daraus lesen.
//
//  Syntax:                                                                    
//
//    new Registry(<openKey>, <subKey> [, <bCreate>]);
//
//    <openKey> ist ein numerischer Wert, der das Handle zum
//              ffnen des Registrierungsschlssels enthlt. Dies ist
//               normalerweise ein in WINREG.H definierter Systemschlssel.
//    <subKey> eine Zeichenfolge, die den Namen eines Unterschlssels
//               von <openKey> enthlt.
//    <bCreate> Flag zum Erzeugen eines Schlssels, fall keiner existiert.
//                    Vorgabe: true.
//
//  Eigenschaften:
//
//    error         -  Enthlt die Windows-Fehlernummer, wenn ein Fehler bei
//                     der letzten Registrierungsoperation auftrat.
//                     Enthlt 0, wenn kein Fehler auftrat.
//    newlyCreated  -  Wird whrend der Instantiierung gesetzt. True, wenn es
//                     sich um einen neuen Schlssel handelt, ansonsten False.
//
// Methoden:
//
//    deleteKey()           - Lscht den aktuellen Schlssel.
//
//    deleteValue([<name>]) - Lscht den benannten Wert aus dem aktuellen
//                            Schlssel. Wenn kein Name bergeben wird, wird der
//                            Standardwert des Schlssels gelscht.
//
//    enumValue() - Liefert ein Array, das die Namen aller im aktuellen Schlssel
//                  enthaltenen Werte beinhaltet.
//
//    queryKeyName() - Liefert den Namen des aktuellen Registrierungsschlssels.
//
//    queryValue(<name>) - Liefert den zu <name> zugehrigen Wert. Der Parameter
//                        <name> ist erforderlich, darf aber leer sein.
//                         Wenn er leer ist, wird der Standardwert des Schlssels zurckgegeben.
//
//    setValue(<name>,<value>[,<type>])
//                       - Setzt den Wert von <name> auf <value>. Beide
//                         Parameter sind erforderlich, aber <name> kann
//                         leer sein, um den Standardwert fr den Schlssel
//                         zu setzen. Liefert ein logisches True oder False, um
//                         das Gelingen bzw. Milingen anzuzeigen. Wenn kein
//                         Typ angegeben wird, wird der Wert gespeichert. Die Typen
//                         sind in WINREG.H definiert.
//
// Beispiel: Verwendung der Klasse Registry, um die Erstellungsebene fr die
//           DBASE-Tabelle auf 7 zu setzen
//
/*
  #include <winreg.h>
  #define BDE_REG_KEY "SOFTWARE\Borland\Database Engine"
  SET PROCEDURE TO "registry.prg" ADDITIVE

  reg = new Registry(HKEY_LOCAL_MACHINE, ;
                     BDE_REG_KEY + ;
                     "\Settings\DRIVERS\DBASE\TABLE CREATE" )
  dbfLevel = reg.queryValue("LEVEL")

  if ( reg.error == 0 )
     if ( dbfLevel <> "7" )
        if (reg.setValue("LEVEL","7"))
           MSGBOX("dBASE-Tabelle auf 7 gesetzt.")
        endif
     endif
  else
     MSGBOX("Fehler beim Lesen der Registrierung.")
  endif
*/
//
//
//  Visual dBASE - Beispielgruppe
//  $Revision:   1.8  $
//
//  Copyright (c) 1997-1998, Borland International, Inc.
//  Alle Rechte vorbehalten.
//
//------------------------------------------------------------------------
//
//

// Define Windows data types for use by the extern command
#include <windef.h>
#include <winreg.h>

class Registry(openKey, subKey, bCreate)
   local nKey, nDisposition, nResult
   nKey         = 0
   nDisposition = -1
   nResult      = 0

   this.openKey = openKey
   this.subKey  = subKey
   this.key     = 0
   this.isOpen  = false
   this.error   = 0
   this.newlyCreated = false
   this.create  = iif(pcount() > 2, bCreate, true )

   class::prototype()

   if ( this.create )
      nResult := RegCreateKeyEx( this.openKey, this.subKey, 0, 0, ;
                                REG_OPTION_NON_VOLATILE,  ;
                                KEY_ALL_ACCESS, ;
                                0, nKey, nDisposition )
   else
      nResult := RegOpenKeyEx(  this.openKey, this.subKey, 0, ;
                                KEY_ALL_ACCESS, ;
                                nKey )
   endif

   // store the handle to this key
   this.key := nKey
   // registry keys should not be held open. If we got a key open
   // close it for now.
   if (nResult == ERROR_SUCCESS)
      if (nDisposition == REG_CREATED_NEW_KEY)
         this.newlyCreated := true
      endif

      this.close()
   else 
      this.error := nResult
   endif

   function close
      this.isOpen := false
      local nResult 
      nResult = RegCloseKey( this.key )

   return (nResult)

   function deleteKey
      local nResult
      nResult = 0
      nResult := RegDeleteKey( this.openKey, this.subKey )
   return ( nResult )

   function deleteValue(keyName)
      local bReturn, nResult
      bReturn = false
      nResult = 0

      // reset the error property
      this.error := 0

      // open up the key
      this.open()

      if (this.isOpen) 
         bReturn := true
         if ( PCOUNT() == 0 )
            // if no parameter is passed, delete default value
            nResult := RegDeleteValue(this.key, "")
         else
            // if one parameter is passed, delete that value
            nResult := RegDeleteValue(this.key, keyName)
         endif

         this.close()
      endif
   return (bReturn)

   function enumValue
      local aReturn, nResult, nCount, sValue, nLen, string80

      aReturn = new Array()
      nResult = ERROR_SUCCESS
      nCount = 0
      sValue = ""
      nLen = 0
      string80 = REPLICATE(" ", 80)

      // reset the error property
      this.error := 0

      // open up the key
      this.open()

      if (this.isOpen) 
         do while (nResult == ERROR_SUCCESS) 
            sValue  := string80
            nLen    := sValue.length
            nResult := RegEnumValue(this.key, nCount, sValue, ;
                        nLen, 0, 0, 0, 0)

            if ( nResult == ERROR_SUCCESS )
               aReturn.add( SUBSTR( sValue, 0, nLen) )
            else 
               if (nResult <> ERROR_NO_MORE_ITEMS )
                  this.error := nResult
               endif
            endif
            nCount ++               
         enddo           
         this.close()
      endif
   return (aReturn)

   function open
      local nResult, nReturn
      nReturn = 0            // handle of new key
      nResult = RegOpenKeyEx( this.openKey, this.subKey, 0, ;
                  KEY_ALL_ACCESS, nReturn)

      if (nResult == ERROR_SUCCESS) 
         this.key = nReturn
         this.isOpen = true
      else
         this.error = (nResult)
      endif
   return (nReturn)

   function prototype
      local bAsian
      bAsian = false
      extern CLONG RegCloseKey( HKEY ) ADVAPI32
      extern CLONG RegCreateKeyEx( HKEY, LPCTSTR, DWORD, LPTSTR, DWORD, ;
                   REGSAM, LPSTRUCTURE, PHKEY, LPDWORD ) ADVAPI32 ;
                   from "RegCreateKeyExA"
      extern CLONG RegDeleteKey(HKEY, LPCSTR) ADVAPI32 ;
                   from "RegDeleteKeyA"
      extern CLONG RegDeleteValue( HKEY, LPTSTR ) ADVAPI32 ;
                   from "RegDeleteValueA"
      extern CLONG RegEnumValue( HKEY, DWORD, LPTSTR, LPDWORD, DWORD, ;
                   LPDWORD, LPBYTE, LPDWORD) ADVAPI32 from "RegEnumValueA"
      extern CLONG RegOpenKeyEx( HKEY, LPCTSTR, DWORD, REGSAM, PHKEY ) ;
                   ADVAPI32 from "RegOpenKeyExA"
      extern CLONG RegQueryValueEx( HKEY, LPTSTR, DWORD, LPDWORD, CSTRING, ;
                   LPDWORD ) ADVAPI32 from "RegQueryValueExA"
      extern CLONG RegSetValueEx( HKEY, LPCTSTR, DWORD, DWORD, CSTRING, DWORD ) ;
                   ADVAPI32 from "RegSetValueExA"
#ifdef __asian__  
      extern CLONG RegQueryValueExChar( HKEY, LPTSTR, DWORD, LPDWORD, CSTRING, ;
                   LPDWORD ) ADVAPI32 from "RegQueryValueExA"
      extern CLONG RegSetValueExChar( HKEY, LPCTSTR, DWORD, DWORD, CSTRING, DWORD ) ;
                   ADVAPI32 from "RegSetValueExA"
      bAsian := true
#endif

   return (bAsian)

   function queryKeyName
      local keyName
      keyName = ""

      do case
         case ( this.openKey == HKEY_CLASSES_ROOT )
              keyName := "HKEY_CLASSES_ROOT\\"
         case ( this.openKey == HKEY_CURRENT_USER )
              keyName := "HKEY_CURRENT_USER\\"
         case ( this.openKey == HKEY_LOCAL_MACHINE )
               keyName := "HKEY_LOCAL_MACHINE\\"
         case ( this.openKey == HKEY_USERS )
              keyName := "HKEY_USERS\\"
         case ( this.openKey == HKEY_PERFORMANCE_DATA )
              keyName := "HKEY_PERFORMANCE_DATA\\"
         case ( this.openKey == HKEY_CURRENT_CONFIG )
              keyName := "HKEY_CURRENT_CONFIG\\"
         case ( this.openKey == HKEY_DYN_DATA )
              keyName := "HKEY_DYN_DATA\\"
         otherwise
            keyName := "UNKNOWN_KEY\\"
      endcase

   return (keyName + this.subKey)

   function queryValue(keyName)
      local nResult, nType, nLen, keyValue
      local strEx, cData
      nResult  = 0 
      nType    = 0
      nLen     = 80
      keyValue = false

      strEx = ""
      cData = REPLICATE(" ", 80)

      // reset the error property
      this.error := 0

      // open up the key
      this.open()

      if (this.isOpen) 
         // query the value
         nResult := RegQueryValueEx(this.key, keyName, 0, ;
                    nType, cData, nLen)

         // ERROR_MORE_DATA means we need to pass a larger cData
         if (nResult == ERROR_MORE_DATA)
            cData   := REPLICATE(" ", nLen)
            nResult := RegQueryValueEx(this.key, keyName, 0, ;
                       nType, cData, nLen)

        endif

#ifdef __asian__
         // The Asian version uses Unicode strings. Call RegQueryValueExChar, which 
         // is prototyped to char*, which converts the string to multi-byte.
         if ( nResult == ERROR_SUCCESS AND nType == REG_SZ )
            cData   := REPLICATE(" ", nLen)
            nResult := RegQueryValueExChar(this.key, keyName, 0, nType, cData, nLen)
         endif
#endif

         strEx := cData
         if (nResult == ERROR_SUCCESS)
            if (nType == REG_DWORD)
               keyValue := strEx.asc(strEx.substring(0, 1)) * ( 256 ^ 0 ) + ;
                           strEx.asc(strEx.substring(1, 2)) * ( 256 ^ 1 ) + ;
                           strEx.asc(strEx.substring(2, 3)) * ( 256 ^ 2 ) + ;
                           strEx.asc(strEx.substring(3, 4)) * ( 256 ^ 3 )
            else 
               keyValue := SUBSTR(strEx, 1, nLen - 1  )
            endif
         else
            this.error := nResult
         endif
         this.close()
      endif
   return (keyValue)

   function setValue( valueName, value, type ) 
      local bReturn, nType, xValue, nAtNull, nLen, nResult
      private typeVal
      bReturn = false
      nType   = IIF( PCOUNT() == 3, type, REG_SZ )
      typeVal = value
      xValue  = value
      nAtNull = 0
      nLen    = 0
      nResult = 0

      // reset the error property
      this.error := 0

      // open the key
      this.open()

      if (this.isOpen) 
         // reformat data if necessary
         if (nType == REG_DWORD) 
            if TYPE("typeVal") == "C"
               xValue := VAL(value)
            endif
            xValue := CHR( INT( xValue / ( 256 ^ 0 ) ) % 256) + ;
                      CHR( INT( xValue / ( 256 ^ 1 ) ) % 256) + ;
                      CHR( INT( xValue / ( 256 ^ 2 ) ) % 256) + ;
                      CHR( INT( xValue / ( 256 ^ 3 ) ) % 256)
         else 
            xValue  := value + "" // force to string type
            nAtNull := AT( CHR(0), xValue )
            if ( nAtNull > 0 ) 
               xValue := SUBSTR( xValue, 1, nAtNull + 1 )
            else
               xValue := xValue + CHR(0)
            endif
         endif

         // Write the data to the registry
         nLen := LEN( xValue )
#ifdef __asian__
         if (nType == REG_SZ)
            nResult := RegSetValueExChar(this.key, valueName, ;
                         0, nType, xValue, nLen)
         else 
#endif
            nResult := RegSetValueEx(this.key, valueName, ;
                         0, nType, xValue, nLen)
#ifdef __asian__
         endif
#endif

         if (nResult == ERROR_SUCCESS)
            bReturn := true
         else
            this.error = (lnResult)
         endif
         this.close()
      endif
   return (bReturn)
endclass

function GetBDEVersion

** Function to return the current BDE Version number and date
**
** Revised: 29-05-1999 
** Version 2.0
**  Completely rewrote because BDE DbiGetSysVersion() in BDE 5.01 returned
**   5.00. <sigh>  Now uses API calls to get idapi32.dll version information
**
** Written: 28-05-1999 David Peters (dpeters@databasesolutions.com.au)
** Version: 1.0
**
** Usage: s = GetBDEVersion()
**        Where s will be a string containing BDE version information

#include <winreg.h>

   // Load the API functions we need
   if ( TYPE("GetFileVersionInfoSizeA") # "FP" )
      EXTERN CINT GetFileVersionInfoSizeA(CSTRING, CPTR CINT) version
   endif
   if ( TYPE("GetFileVersionInfoA") # "FP" )
      EXTERN CINT GetFileVersionInfoA(CSTRING, CINT, CINT, CPTR) version
   endif

   // Setup some variables
   local n, iVersionSize, sBuffer, iStart, c, sReturnString, sBDEPath
   n = 0
   sReturnString = new string()

   // Get the location of the BDE from the registry
   r = new registry(HKEY_LOCAL_MACHINE, "Software\Borland\Database Engine", false)
   sBDEPath = r.queryValue("DLLPATH")

   // Strip the trailing ";" off the BDE path
   if ( sBDEPath.right(1) = ";" )
      sBDEPath = sBDEPath.left(sBDEPath.length-1)
   endif

   // Get the size of the BDE idapi32.dll version information data
   iVersionSize = GetFileVersionInfoSizeA(sBDEPath+"\idapi32.dll"+CHR(0), n)

   // Create a buffer to store the version information data
   sBuffer = new STRING(SPACE(iVersionSize)+1)

   // Get the BDE idapi32.dll version information
   GetFileVersionInfoA(sBDEPath+"\idapi32.dll", 0, iVersionSize, sBuffer)

   // Because we are lucky enough that GetFileVersion always returns a unicode
   // structure we can get the info we need by doing a bit of string 
   // manipulation which is easier than calling VerQueryValue()

   // Find the FileVersion header
   iStart = AT("FileVersion", sBuffer)
   if ( EMPTY(iStart) )
      sReturnString = "Error"
   else
      // Skip past "FileVersion\000\000" in the structure
      iStart += 12

      // While we don't hit any nulls, get the version string
      isNull = false
      do while not isNull
         c = sBuffer.CharAt(iStart)
         if ( ASC(c) = 0 or iStart > 1024 )
            isNull = true
         else
            sReturnString += c
         endif
         iStart++
      enddo
   endif
return (sReturnString)

